package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.DistrictInfo;
import com.izouma.awesomeadmin.service.DistrictInfoService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/districtInfo")
@RequiresAuthentication
public class DistrictInfoController {

    @Autowired
    private DistrictInfoService districtInfoService;

    /**
    * <p>获取全部记录。</p>
    */
//    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(DistrictInfo record) {
        List<DistrictInfo> pp = districtInfoService.getDistrictInfoList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getDistrictInfo", method = RequestMethod.GET)
    @ResponseBody
    public Result getDistrictInfo(@RequestParam(required = false, value = "id") String id) {
        DistrictInfo data = districtInfoService.getDistrictInfoById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(DistrictInfo record) {
        DistrictInfo data = districtInfoService.getDistrictInfo(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, DistrictInfo record) {
        Map<String, Object> result = new HashMap<>();

        List<DistrictInfo> pp =districtInfoService.getDistrictInfoByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(DistrictInfo record) {
        boolean num = districtInfoService.createDistrictInfo(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateDistrictInfo(DistrictInfo record) {
        boolean num = districtInfoService.updateDistrictInfo(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteDistrictInfo(@RequestParam(required = true, value = "id") String id) {

        boolean num = districtInfoService.deleteDistrictInfo(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, DistrictInfo record) throws Exception {

    List<DistrictInfo> districtInfos = districtInfoService.getDistrictInfoList(record);


        String sheetName = "district_info";
        String titleName = "区域数据表";
        String fileName = "区域表";
        int columnNumber = 10;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "国家编码" ,   "名称" ,   "描述" ,   "排序"  };
        String[][] dataList = new String[districtInfos.size()][10];

        for (int i = 0; i < districtInfos.size(); i++) {

                        dataList[i][0] = String.valueOf(districtInfos.get(i).getId());
                        dataList[i][1] = String.valueOf(districtInfos.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(districtInfos.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(districtInfos.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(districtInfos.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(districtInfos.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(districtInfos.get(i).getCode());
                        dataList[i][7] = String.valueOf(districtInfos.get(i).getDistrictName());
                        dataList[i][8] = String.valueOf(districtInfos.get(i).getDescription());
                        dataList[i][9] = String.valueOf(districtInfos.get(i).getRank());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

